Subject: [Json] [Technical Errata Reported] RFC7159 (3983)

From: RFC Errata System <[email-masked]>
Date: Fri, 9 May 2014 00:29:01 -0700 (PDT)

The following errata report has been submitted for RFC7159,
"The JavaScript Object Notation (JSON) Data Interchange Format".

--------------------------------------
You may review the report below and at:
http://www.rfc-editor.org/errata_search.php?rfc=7159&eid=3983

--------------------------------------
Type: Technical
Reported by: Alain BENEDETTI <[email-masked]>

Section: 2.

Original Text
-------------
JSON-text = ws value ws

Corrected Text
--------------
JSON-text = [BOM] ws value ws

BOM = %xFEFF

Notes
-----
Section 8.1 states:
[START QUOTE]
(...) implementations that parse JSON texts *MAY* ignore the presence of a byte order mark rather than treating it as an error.
[END QUOTE]

Indeed that means that a BOM *CAN* occur, and *MAY* be accepted instead of returning an error. So, if the BOM can be accepted, the grammar is incomplete as it does not show it.

Furthermore, about BOMs, see my other comments.

Instructions:
-------------
This errata is currently posted as "Reported". If necessary, please
use "Reply All" to discuss whether it should be verified or
rejected. When a decision is reached, the verifying party (IESG)
can log in to change the status and edit the report, if necessary. 

--------------------------------------
RFC7159 (draft-ietf-json-rfc4627bis-rfc7159bis)
--------------------------------------
Title               : The JavaScript Object Notation (JSON) Data Interchange Format
Publication Date    : March 2014
Author(s)           : T. Bray, Ed.
Category            : PROPOSED STANDARD
Source              : JavaScript Object Notation
Area                : Applications
Stream              : IETF
Verifying Party     : IESG

---

From: Carsten Bormann <[email-masked]>
Date: Fri, 9 May 2014 09:48:26 +0200

The grammar in RFC 7159 is correct as it is; this errata should be rejected.
There has been strong consensus in the WG that JSON texts do not include byte order marks.
A license for receivers to be tolerant of a certain class of errors does not change this.

we maybe should write:

> (...) implementations that parse JSON texts *MAY* ignore the presence of a byte order mark in front of a JSON text rather than treating it as an error.

Grüße, Carsten

---

From: Matt Miller <[email-masked]>
Date: Fri, 9 May 2014 10:09:30 -0600

RFC Editor: Please reject this erratum.

The WG consensus was to exclude the byte-order from the ABNF, and
leave it to implementations whether to be more liberal in what is
accepted.

Thank you,

- -- 
- - m&m

Matt Miller < [email-masked] >
Cisco Systems, Inc.

On 5/9/14, 1:29 AM, RFC Errata System wrote:
> The following errata report has been submitted for RFC7159, "The
> JavaScript Object Notation (JSON) Data Interchange Format".
> 
> -------------------------------------- You may review the report
> below and at: 
> -------------------------------------- Type: Technical Reported by:
> Alain BENEDETTI <[email-masked]>
> 
> Section: 2.
> 
> Original Text ------------- JSON-text = ws value ws
> 
> Corrected Text -------------- JSON-text = [BOM] ws value ws
> 
> BOM = %xFEFF
> 
> Notes ----- Section 8.1 states: [START QUOTE] (...) implementations
> that parse JSON texts *MAY* ignore the presence of a byte order
> mark rather than treating it as an error. [END QUOTE]
> 
> Indeed that means that a BOM *CAN* occur, and *MAY* be accepted
> instead of returning an error. So, if the BOM can be accepted, the
> grammar is incomplete as it does not show it.
> 
> Instructions: ------------- This errata is currently posted as
> "Reported". If necessary, please use "Reply All" to discuss whether
> it should be verified or rejected. When a decision is reached, the
> verifying party (IESG) can log in to change the status and edit the
> report, if necessary.
> 
> -------------------------------------- RFC7159
> (draft-ietf-json-rfc4627bis-rfc7159bis) 
> -------------------------------------- Title               : The
> JavaScript Object Notation (JSON) Data Interchange Format 
> Publication Date    : March 2014 Author(s)           : T. Bray,
> Ed. Category            : PROPOSED STANDARD Source              :
> JavaScript Object Notation Area                : Applications 
> Stream              : IETF Verifying Party     : IESG
>

---

From: Pete Resnick <[email-masked]>
Date: Fri, 9 May 2014 17:36:23 -0500

Actually, it's an AD who marks things as Verified/Rejected/etc., so I 
will go do so (with this and the other).

pr

On 5/9/14 11:09 AM, Matt Miller wrote:
> -----BEGIN PGP SIGNED MESSAGE-----
> Hash: SHA512
>
> Matt Miller<  [email-masked]>
> Cisco Systems, Inc.
>
>> Alain BENEDETTI<[email-masked]>
>>
>> Section: 2.
>>
> -----BEGIN PGP SIGNATURE-----
> Version: GnuPG/MacGPG2 v2.0.22 (Darwin)
> Comment: GPGTools - https://gpgtools.org
> Comment: Using GnuPG with Thunderbird - http://www.enigmail.net/
>
> iQEcBAEBCgAGBQJTbP26AAoJEDWi+S0W7cO1g5gH/0kqDoYdYfJ+V4DUgTThKczf
> JmQAc8BjLo9IzOnDN8IlcSqd1mdQa0r5G0EltnPilmoSVz6JBpxRZ81psGhXFxyX
> 8h33e0mF1BYqSZ/I9NWNX9ClKGTrKLH6pnzJyVUrgY24hVmQogE2sqIEuNF9mB+J
> jVdVYbfKYLogrPDhUcic1qEQQOccYcoihAxmtpSmQirGXtL1zH1Wl77mEu7B30CA
> SGVRlV2u6caDFkdWZc8NtWAf1QgWExVYaQT1JWUO2ySdsi0wgMeEZAK9nB479ke3
> DcYdvANa5CmowclivUefOdVJa80eDHCUp4Aun/7G33hmu5vgBeM0BmQP9gU7GiE=
> =4lkO
> -----END PGP SIGNATURE-----
>    

-- 
Pete Resnick<http://www.qualcomm.com/~presnick/>
Qualcomm Technologies, Inc. - +1 (858)651-4478